library MyTempDir;

uses SysUtils, Classes;

{$E .plg}
{$R *.res}

type
  //  GET
  TURLGet = function (const URL: PChar): PChar; stdcall;
  //  POST,   -    
  // : _1=_1 #10 _2=_2  
  TURLPost = function (const URL, Data: PChar): PChar; stdcall;
  //    
  TSaveToLog = procedure (const AText: PChar); stdcall;
  //  (   Dialogs)
  TShowMsg = function (const AText: PChar; const mode: Byte): Integer; stdcall; //0 - info, 1 - confirmation, 2 - Error
  //    .    
  TSaveToFile = procedure (const AName, AContent: PChar); stdcall;

var URLGet: TURLGet;
    URLPost: TURLPost;
    FDebug: Boolean;
    WorkDir: AnsiString;
    SaveToLog: TSaveToLog;
    SaveToFile: TSaveToFile;
    ShowMsg: TShowMsg;

//-    MyTempDir -----------------------------------------------------------------------    

function Hex2Dec(const S: string): Longint;
var
  HexStr: string;
begin
  if Pos('$', S) = 0 then HexStr := '$' + S
  else HexStr := S;
  Result := StrToIntDef(HexStr, 0);
end;

function SevBit2WIN(const mm: AnsiString): AnsiString;
const  HexArr = ['0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','a','b','c','d','e','f'];
var i,n: Integer;
begin
  Result:='';
  if mm='' then exit;
  SetLength(Result,length(mm));
  i:=1;
  n:=1;
  repeat
    if ((mm[i]='=') or (mm[i]='%') or
       ((i>1) and (mm[i-1]='\') and (mm[i]=''''))) and
       (mm[i+1] in HexArr) and
       (mm[i+2] in HexArr) then begin
          if mm[i]='''' then dec(n);
          Result[n]:=chr(Hex2Dec(copy(mm,i+1,2)));
          inc(i,2);
          inc(n);
    end else begin
      // =#13  =#10 -    
      if (mm[i]='=') and (i<length(mm)) and ((mm[i+1]=#10) or (mm[i+1]=#13)) then
        inc(i,2)//  
      else begin
        Result[n]:=mm[i];
        inc(n);
      end;
    end;
    inc(i);
  until i>length(mm);
  Result:=copy(Result,1,n-1);
end;




//-----------------------------------------------------------------------------------------------
//    --------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------

//    . 
function PlgInit(const funcGet, funcPost, funcSavetoLog, funcShowMsg, funcSaveToFile: Pointer;const Debug: byte; const AWorkDir: PChar): PChar; stdcall;
begin
  @URLGet:=funcGet;             //   GET
  @URLPost:=funcPost;           //   POST
  @SaveToLog:=funcSavetoLog;    //   SaveToLog
  @SaveToFile:=funcSaveToFile;  //   SaveToFile
  @ShowMsg:=funcShowMsg;        //   ShowMsg

  FDebug:=Debug=1;              //  /
  WorkDir:=StrPas(AWorkDir);    //  (     )

  Result:='mytempdir.com';      //   . . 
                                //  URL    -  
                                //   .   
end;

//  -    ""      
//      -  "http://sr1.mytempdir.com/116387"
//  ,     :
//%deleted% -     
//%notfound% -      ( ?)
//    -          
//  5  (      30   
//    ,   ""      )
function PlgGetDirectLink(const MyTempDirLnk: PChar): PChar; stdcall;
var s: AnsiString;
    n: Integer;
begin
  Result:='';

  s:=StrPas(URLGet(PChar(MyTempDirLnk)));
  if s='' then exit;

  if FDebug then
    SaveToFile(PChar(WorkDir+'MyTempDir.html'),PChar(s));

  if pos('file was removed',s)>0 then begin
    Result:='%deleted%';
    exit;
  end;

  if pos('Wrong file ID.',s)>0 then begin
    Result:='%notfound%';
    exit;
  end;

  n:=pos('.innerHTML = unescape(''',s);
  if n=0 then exit;
  inc(n,23);//  
  s:=copy(s,n,MaxInt);

  n:=pos(''')',s);
  if n=0 then exit;
  s:=SevBit2WIN(copy(s,1,n-1));

  n:=pos('http://sr',s);
  if n=0 then exit;
  s:=copy(s,n,MaxInt);

  n:=pos('">',s);
  if n=0 then exit;

  s:=copy(s,1,n-1);

  Result:=StrAlloc(length(s)+1);
  StrPCopy(Result,s);
end;

//   
procedure PlgDestroy; stdcall;
begin
  @URLGet:=nil;
  @URLPost:=nil;
end;

exports
  PlgInit,
  PlgGetDirectLink,
  PlgDestroy;

begin
end.
 
